--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   21:01:06 12/12/2008
-- Design Name:   
-- Module Name:   C:/Dokumente und Einstellungen/user/RE/CPUProject/tb_address.vhd
-- Project Name:  CPUProject
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: AdressInterface
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
use WORK.CPU_PACKAGE.ALL ;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.ALL;
USE ieee.numeric_std.ALL;
 
ENTITY tb_address IS
END tb_address;
 
ARCHITECTURE behavior OF tb_address IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT AdressInterface
    PORT(
         Reset : IN  std_logic;
         Clk : IN  std_logic;
         AdressBusIn : IN  std_logic_vector(7 downto 0);
         AdressBusOut : OUT  std_logic_vector(7 downto 0);
		 DataToMemory: out std_logic_vector(3 downto 0) ;
         DataFromMemory : IN  std_logic_vector(3 downto 0);
         DToControl : OUT  std_logic_vector(3 downto 0);
         PCOut : IN  std_logic_vector(3 downto 0);
         AccOut : IN  std_logic_vector(3 downto 0);
         MemEn : IN  std_logic;
         RW : IN  std_logic;
         RWOut : OUT  std_logic;
         SelectSource : IN  std_logic
        );
    END COMPONENT;
	 
	component sram
    port (
			a: IN std_logic_VECTOR(7 downto 0);
			d: IN std_logic_VECTOR(3 downto 0);
			clk: IN std_logic;
			we: IN std_logic;
			spo: OUT std_logic_VECTOR(3 downto 0));
	end component;
			
   --Inputs
   signal Reset : std_logic := '0';
   signal Clk : std_logic := '0';
   signal AdressBusIn : std_logic_vector(7 downto 0) := (others => '0');
   signal DataFromMemory : std_logic_vector(3 downto 0) := (others => '0');
   signal DataToMemory : std_logic_vector(3 downto 0) := (others => '0');
   signal PCOut : std_logic_vector(3 downto 0) := (others => '0');
   signal AccOut : std_logic_vector(3 downto 0) := (others => '0');
   signal MemEn : std_logic := '0' ;
   signal RW : std_logic := '0';
   signal SelectSource : std_logic := '0';

 	--Outputs
   signal AdressBusOut : std_logic_vector(7 downto 0);
   signal DToControl : std_logic_vector(3 downto 0);
   signal RWOut : std_logic;
 
	constant Clk_period:time := 10 ns;
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: AdressInterface PORT MAP (			 
			 Reset => Reset,
          Clk => Clk,
          AdressBusIn => AdressBusIn,
          AdressBusOut => AdressBusOut,
			 DataToMemory => DataToMemory,
          DataFromMemory => DataFromMemory,
          DToControl => DToControl,
          PCOut => PCOut,
          AccOut => AccOut,
          MemEn => MemEn,
          RW => RW,
          RWOut => RWOut,
          SelectSource => SelectSource
        );
		  	
	ram0 : sram
        port map (
            a => AdressBusOut,
            d => DataToMemory,
            Clk => Clk,
            we => RWOut,
            spo => DataFromMemory);

   -- No clocks detected in port list. Replace <clock> below with 
   -- appropriate port name 
  
   Clk_process :process
   begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
   end process;
	
	
   -- Stimulus process
   stim_proc: process
   begin	
		Reset <= '1' ;
     	wait for 10 ns ;
		Reset <= '0' ;
		
		AdressBusIn <= conv_std_logic_vector(0, 8) ;
		MemEn <= '1' ;
		RW <= '0' ;
		SelectSource <= '0' ;
		wait for Clk_period ;
		AdressBusIn <= conv_std_logic_vector(1, 8) ;
		wait for Clk_period ;
		AdressBusIn <= conv_std_logic_vector(2, 8) ;
		wait for clk_period ;
		MemEn <= '0' ;
				
      wait;
   end process;

END;
